| Flutter Impeller |

Public Types | Public Member Functions | Public Attributes | List of all members
impeller::Path::Polyline Struct Reference

`#include <path.h>`

## Public Types
using | PointBufferPtr = std::unique_ptr< std::vector< Point > >
using | ReclaimPointBufferCallback = std::function< void(PointBufferPtr)>

## Public Member Functions
| Polyline (PointBufferPtr point_buffer, ReclaimPointBufferCallback reclaim)
| Polyline (Polyline &&other)
| ~Polyline ()
Point & | GetPoint (size_t index) const
std::tuple< size_t, size_t > | GetContourPointBounds (size_t contour_index) const

## Public Attributes
PointBufferPtr | points
std::vector< PolylineContour > | contours

## Detailed Description

One or more contours represented as a series of points and indices in the point vector representing the start of a new contour.

Polylines are ephemeral and meant to be used by the tessellator. They do not allocate their own point vectors to allow for optimizations around allocation and reuse of arenas.

Definition at line 98 of file path.h.

## Member Typedef Documentation

## ◆ PointBufferPtr

using impeller::Path::Polyline::PointBufferPtr = std::unique_ptr<std::vector<Point> >

The signature of a method called when it is safe to reclaim the point buffer provided to the constructor of this object.

Definition at line 101 of file path.h.

## ◆ ReclaimPointBufferCallback

using impeller::Path::Polyline::ReclaimPointBufferCallback = std::function<void(PointBufferPtr)>

Definition at line 102 of file path.h.

## Constructor & Destructor Documentation

## ◆ Polyline() [1/2]

impeller::Path::Polyline::Polyline | ( | PointBufferPtr | point_buffer,
|  | ReclaimPointBufferCallback | reclaim
| ) |  |

The buffer will be cleared and returned at the destruction of this polyline.

Definition at line 234 of file path.cc.

236 : points(std::move(point_buffer)), reclaim_points_(std::move(reclaim)) {
237 FML_DCHECK(points);
238 }

References points.

## ◆ Polyline() [2/2]

impeller::Path::Polyline::Polyline | ( | Path::Polyline && | other | ) |

Definition at line 240 of file path.cc.

240 {
241 points = std::move(other.points);
242 reclaim_points_ = std::move(other.reclaim_points_);
243 contours = std::move(other.contours);
244 }

## ◆ ~Polyline()

impeller::Path::Polyline::~Polyline | ( |  | ) |

Definition at line 246 of file path.cc.

246 {
247 if (reclaim_points_) {
248 points->clear();
249 reclaim_points_(std::move(points));
250 }
251 }

## Member Function Documentation

## ◆ GetContourPointBounds()

std::tuple< size_t, size_t > impeller::Path::Polyline::GetContourPointBounds | ( | size_t | contour_index | ) | const

Convenience method to compute the start (inclusive) and end (exclusive) point of the given contour index.

The contour_index parameter is clamped to contours.size().

Definition at line 22 of file path.cc.

23 {
24 if (contour_index >= contours.size()) {
25 return {points->size(), points->size()};
26 }
27 const size_t start_index = contours.at(contour_index).start_index;
28 const size_t end_index = (contour_index >= contours.size() - 1)
29 ? points->size()
30 : contours.at(contour_index + 1).start_index;
31 return std::make_tuple(start_index, end_index);
32 }

References contours, and points.

Referenced by impeller::Tessellator::TessellateConvex(), and impeller::testing::TEST().

## ◆ GetPoint()

Point& impeller::Path::Polyline::GetPoint | ( | size_t | index | ) | const
| inline

Definition at line 115 of file path.h.

115 { return (*points)[index]; }

References points.

Referenced by impeller::testing::TEST().

## Member Data Documentation

## ◆ contours

std::vector<PolylineContour> impeller::Path::Polyline::contours

Contours are disconnected pieces of a polyline, such as when a MoveTo was issued on a PathBuilder.

Definition at line 119 of file path.h.

Referenced by impeller::Path::CreatePolyline(), GetContourPointBounds(), and impeller::testing::TEST().

## ◆ points

PointBufferPtr impeller::Path::Polyline::points

Points in the polyline, which may represent multiple contours specified by indices in |contours|.

Definition at line 113 of file path.h.

Referenced by impeller::Path::CreatePolyline(), GetContourPointBounds(), GetPoint(), Polyline(), and impeller::testing::TEST().

The documentation for this struct was generated from the following files:

- impeller/geometry/path.h
- impeller/geometry/path.cc

impeller::Path::Polyline::points
PointBufferPtr points
Definition: path.h:113
impeller::Path::Polyline::contours
std::vector< PolylineContour > contours
Definition: path.h:119